WATCH(1)

NOME
watch - executa um programa periodicamente, mostrando saída em tela cheia

SINOPSE
watch [opções] comando

DESCRIÇÃO
watch executa comando repetidamente, exibindo a saída e os erros (o primeiro de tela inteira). Isso permite que você acompanhe a mudança da saída do programa ao longo do tempo. Por padrão, comando é executado a cada 2 segundos e watch será executado até ser interrompido.

OPÇÕES

-d, --differences[=permanente]
    Realça as diferenças entre as atualizações sucessivas. Se o argumento permanente opcional for especificado, watch vai mostrar todas as alterações desde a primeira iteração.

-n, --interval segundos
    Especifica o intervalo de atualização. O comando não permitirá um intervalo mais rápido do que 0,1 segundo, no qual os valores menores são convertidos. Ambos "." e "," funcionam para qualquer localidades. O ambiente WATCH_INTERVAL pode ser usado para definir persistentemente um intervalo não padrão (seguindo as mesmas regras e formatação).

-p, --precise
    Faz o watch tentar executar o comando a cada --interval segundos. Experimente com ntptime (se disponível) e perceba como os segundos fracionários permanecem (quase) os mesmos, em oposição ao modo normal onde aumentam continuamente.

-t, --no-title
    Desligue o cabeçalho mostrando o intervalo, comando e tempo atual na parte superior da tela, bem como a seguinte linha em branco.

-b, --beep
    Apita se o comando tem uma saída anormal, com código não zero.

-e, --errexit
    Congela atualizações quando houver um erro no comando, e sai após um tecla ser pressionada.

-g, --chgexit
    Sai quando a saída de comando alterar.

-q, --equexit <cycles>
    Exit when output of command does not change for the given number of cycles.

-c, --color
    Interpreta cores ANSI e sequências de estilo.

-x, --exec
    Passa comando para exec(2) em vez de sh -c, o que reduz a necessidade de usar aspas extras para obter o efeito desejado.

-w, --no-wrap
    Desativa quebra de linha. Linhas longas serão truncadas em vez de quebradas para a próxima linha.

-h, --help
    Exibe um texto de ajuda e sai.

-v, --version
    Exibe informação da versão e sai.

STATUS DE SAÍDA

    0   Sucesso.
    1   Várias falhas.
    2   O fork do processo a ser assistido falhou.
    3   Substituição da stdout (saída padrão) do processo filho com pipe lateral de escrita falhou.
    4   Execução do comando falhou.
    5   Encerramento do pipe de escrita do processo filho falhou.
    7   Criação de pipe IPC falhou.
    8   Obtenção de valor de retorno de processo filho com waitpid(2) falhou, ou o comando saiu com um erro.
    outro
        O watch vai propagar o status de saída do comando como status de saída de filho.

AMBIENTE
O comportamento de watch é afetado pelas seguintes variáveis de ambiente.
WATCH_INTERVAL
    Intervalo de atualização, segue as mesmas regras da opção de linha de comando --interval.

NOTAS
O processamento de opções POSIX é usado, ou seja, o processamento de opções interrompe no primeiro argumento sem opção. Isso significa que as opções após comando não são interpretadas pelo próprio watch.

ERROS
Após o redimensionamento do terminal, a tela não será redesenhada corretamente até a próxima atualização agendada. Todos os realces de --differences são perdidas nessa atualização também. Caracteres não imprimíveis são removidos da saída do programa. Use cat -v como parte do pipeline de comando se você quiser vê-los. Caracteres de Combinação que devem ser exibidos no caractere na última coluna na tela podem ser exibidos uma coluna antes ou podem não ser exibidos. Caracteres de Combinação nunca contam como diferente no modo --differences. Apenas só caracteres base contam. As linhas em branco diretamente após uma linha que termina na última coluna não são exibidas. O modo --precise ainda não possui tecnologia de distorção temporal avançada para compensar um comando que leva mais de --interval segundos para executar. watch também pode entrar em um estado no qual ele dispara rapidamente tantas execuções do comando quanto possível para recuperar as execuções anteriores que funcionam por mais tempo que --interval (por exemplo, netstat levando muito tempo em uma pesquisa de DNS).

EXEMPLOS
Para monitorar por correio, você pode fazer
    watch -n 60 from
Para assistir o conteúdo de um diretório mudar, você pode usar
    watch -d ls -l
Se você está interessado apenas em arquivos pertencentes ao usuário fulano, você pode usar
    watch -d 'ls -l | fgrep fulano'
Para ver os efeitos das aspas, tente esses aqui
    watch echo $$
    watch echo '$$'
    watch echo "'"'$$'"'"
Para ver o efeito da manutenção da precisão do tempo, tente adicionar -p a
    watch -n 10 sleep 1
Você pode assistir seu administrador para instalar o kernel mais recente com
    watch uname -r
(Note que não há garantia de que -p funcione entre reinicializações, especialmente em face de ntpdate (se disponível) ou outros mecanismos de mudança de tempo quando da inicialização)